# jp-car-phone 车信达手机端

## 运行与安装
建议使用uniapp的官方推荐开发工具HBuilder最新版本

## 目录结构
~~~
www  WEB部署目录（或者子目录）
├─apis             接口目录
├─components       组件目录
├─config           配置目录
├─pages            页面目录
├─static           静态文件目录
├─utils            工具模块目录
├─App.vue          主入口组件
├─main.js          主入口模块
├─mainifest.json   项目配置
├─pages.json       页面及其他公共配置
├─uni.scss         控制应用的风格样式文件
├─vue.config.js    vue配置，多不可用，具体参见文档https://uniapp.dcloud.io/collocation/vue-config
~~~

## 编码风格
- 文件命名建议使用驼峰命名,其中首字母小写，名字要语义清晰
- data内参数或者函数参数使用驼峰命名，关键参数或者有歧义的参数应该有参考备注
- 页面的命名使用驼峰命名，而组件的命名则使用中划线命名，将两者能够更好的分别
- 在页面内定义函数和参数需要有备注，定义此方法的含义及其使用， 生命周期函数推荐使用uni-app的内置自带函数，不推荐使用vue的生命函数
- 在页面中使用this 推荐在全局置顶设置_this 这样会保持风格统一 且节省代码
- 在页面头部起一行注释，表明这个页面是什么页面 
- 以前的html标签改了很多，请参照官方文档使用
`div 改成 view`
`span、font 改成 text`
`a 改成 navigator`
`img 改成 image`
`input 还在，但type属性改成了confirmtype`
`form、button、checkbox、radio、label、textarea、canvas、video 这些还在。`
`select 改成 picker`
`iframe 改成 web-view`
`ul、li没有了，都用view替代`

##插件引用
#控制台
yarn add vconsole
###uniapp 路由站
npm install uni-simple-router uni-read-pages(取消使用， 存在h5 刷新白屏问题）
//双路由   uni-crazy-router 直接链接访问， 无法触发前置占点
[uni-crazy-router](https://ext.dcloud.net.cn/plugin?id=1658)
[bobo-router ](https://ext.dcloud.net.cn/plugin?id=904)



[vue-router-uni ](https://ext.dcloud.net.cn/plugin?id=605)
[mac80端口问题无法使用](https://blog.csdn.net/weixin_41047933/article/details/97765502)
sudo pfctl -ef /etc/pf-tomcat.conf


redirectTo
