import request from '@/utils/request'
import Qs from 'qs';

//帐号密码登录
export function loginUserName(data) {
	return request({
		url: '/mobile/personInfoApi/loginByPassword',
		data: Qs.stringify(data),
		method: 'post',
	})
}

//退出登录
export function loginOut() {
	return request({
		url: '/mobile/personInfoApi/logOut',
		data: {},
		method: 'post',
	})
}

//获取短信验证码
export function getVerifyCode(data) {
	return request({
		url: '/mobile/passengerApi/getVerifyCode',
		data: Qs.stringify(data),
		method: 'post',
	})
}

export function userUpdatePhone(data) {
	return request({
		url: '/mobile/passengerApi/userUpdatePhone',
		data: Qs.stringify(data),
		method: 'post',
	})
}
//验证短信验证码
export function validateCode(data) {
	return request({
		url: '/mobile/passengerApi/validateCode',
		data: Qs.stringify(data),
		method: 'post',
	})
}

//重置密码
export function resetPassword(data) {
	return request({
		url: '/mobile/personInfoApi/resetPassword',
		data: Qs.stringify(data),
		method: 'post',
	})
}

//获取基础信息
export function getBasicInformation() {
	return request({
		url: '/mobile/personInfoApi/basicInformation',
		method: 'post',
	})
}

//提交基础信息
export function submitBasicInformation(data) {
	return request({
		url: '/mobile/personInfoApi/updateBasicInformation',
		data: Qs.stringify(data),
		method: 'post',
	})
}

//关于企联
export function getAboutInfo() {
	return request({
		url: '/mobile/enterpriseInfoApi/enterpriseInfo',
		method: 'post',
	})
}

//变更手机号
export function changePhone(data) {
	return request({
		url: '/mobile/personInfoApi/validateCodeAndUpdatePhone',
		data: Qs.stringify(data),
		method: 'post',
	})
}