import {
	VueCropper
} from 'vue-cropper'
import * as WxJsApi from '@/utils/wxJsApi.js'
	import {
		dataUrlToFile
	} from '@/utils'
import * as API_Common from '@/apis/common'

export default {
	data() {
		return {
			localId:'',
			imgBase64: '',
			cropper: {

				//img的路径自行修改
				img: '',
				info: true,
				size: 0.8,
				outputType: 'jpeg',
				canScale: false,
				autoCrop: true,
				// 只有自动截图开启 宽度高度才生效
				autoCropWidth: 250,
				autoCropHeight: 350,
				fixed: true,
				// 真实的输出宽高
				infoTrue: true,
				fixedNumber: [5, 7],
				fixedBox:true

			},
		}
	},
	components: {
		VueCropper,
	},
	methods: {
		//上传图片
		uploadpic() {
			this.$refs.common.showLoading()
			var _this = this;
			var formData = {
				'photoName': '1.jpg',
				'photoFile': this.imgBase64
			}
			
			API_Common.upload(formData).then(response => {
				
				var obj=this.carhelp.get("form");
				obj.pic=response.data;
				this.carhelp.set("form",obj);
				this.$refs.common.showLoading(false,"上传成功！")
				
				uni.navigateTo({
					url: '/pages/buytickets/confirm'
				})
			}).catch(error => {
				this.$refs.common.showLoading(false,error)
		
			})
		},
		submit(){
			this.$refs.cropper.goAutoCrop();
			this.$refs.cropper.getCropData((data) => {
				this.modelSrc = data
				this.model = false;
				//裁剪后的图片显示
				//this.cropper.img = data;
				//console.log(data)
				this.imgBase64=data;
				this.uploadpic();
			})
		},
		close(){
			step=1;
		},
		rotateRight(){
			this.$refs.cropper.rotateRight()
		},
		getData(res) {
			var localData = res.localData
			if (localData.indexOf('data:image') != 0) {
				//判断是否有这样的头部
				localData = 'data:image/jpeg;base64,' + localData
			}
			localData = localData.replace(/\r|\n/g, '').replace('data:image/jgp', 'data:image/jpeg')
			this.imgBase64 = localData;
			this.cropper.img=localData;
			this.$refs.common.showLoading();
		},imgLoad(){
			this.$refs.common.showLoading(false);
		}
	},
	onLoad(obj) {
		this.localId = obj.localId;
		
	},onReady() {
		this.$refs.common.showLoading()
			 WxJsApi.getWxConfig([ 'getLocalImgData']).then(() => {
			 
			 	WxJsApi.getLocalImgData(this.localId, this.getData);
			 });
		}
}
