import * as API from '@/apis/buytickets.js'


export default {
	data() {
		return {
			isLoading:true,
			initBl:false,
			noback:false,
			passengerInfo:{},
			id: '',
			num: 0,
			pic: '',
			list: [],
			selectList: [],
			subForm: {
				pageIndex: 1,
				pageSize: 20,
				totalPage: 1
			}
		}
	},
	methods: {
		gotoHome(){
			uni.switchTab({
			    url: '/pages/index/index'
			});
		},
		
		submit() {
			var obj = this.carhelp.get("form");
			obj.oplist = []
			for (var i in this.list) {
				if (this.list[i].ck) {
					obj.oplist.push(this.list[i]);
				}
			}
			this.carhelp.set("form", obj);

			uni.navigateTo({
				url: '/pages/buytickets/selectSite?select=true&id=' + this.id
			})
		},
		ckBtn(item) {
			if(this.num==5&&!item.ck){
				this.$refs.common.alert("一次最多选择5名乘车人员");
				return
			}
			item.ck = !item.ck;

			if (item.ck) {
				var bl=true
				for (var i = 0; i < this.selectList.length; i++) {
					if (this.selectList[i].upStationId != item.upStationId) {
						bl=false;
					
					}
					break;
				}
				if(!bl){
					item.ck = !item.ck;
					this.$refs.common.alert("所选乘客上车站点不一致，请重新选择。");
					return;
				}
				this.num++;
				this.selectList.push(item);
			} else {
				this.num--;
				for (var i = 0; i < this.selectList.length; i++) {
					if (this.selectList[i].id == item.id) {
						this.selectList.splice(i, 1);
					}
				}
			}
			console.log(this.selectList)
		},
		getPassengerInfo() {
			
			
			var thisform = {
				id: this.id,
				openId: this.carhelp.getOpenId()
			}
			this.$refs.common.showLoading()
		
			API.getPassengerInfo(thisform).then((response) => {
				if (!response.result) {
					this.$refs.common.goError(response.message)
					return
				}
				this.passengerInfo = response.data
				
				var obj = this.carhelp.get("form");
				if(!obj){
					obj={}
				}
				
				//obj.list = this.passengerInfo.list;
				obj.name= 'buytickets';
				obj.id= this.id;
				this.carhelp.set("form", obj);
				
				if (response.data.supply) {
					this.$refs.common.alert('存在需要补票的订单。')
					
					uni.switchTab({
						url: '/pages/news/index'
					});
					return;
					//this.$refs.common.goError(response.message)
					this.$refs.common.setFnc(()=>{
						uni.switchTab({
							url: '/pages/news/index'
						});
					},()=>{
						if (!response.data.id) {
							uni.redirectTo({
								url: '/pages/buytickets/index?id=' + this.id+'&back=true'
							})
						} else {
							
							this.getShiftInfo()
						}
					})
					this.$refs.common.confirm('存在需要补票的订单，是否前去查看？')
				return;
				}
				
				this.upBusNoTicketList(true);
				
			}).catch(error => {
		
				if (error) {
					this.$refs.common.goError(error)
					return
				}
				//this.$refs.common.showLoading(false,error)
			})
		},
		upBusNoTicketList(bl) {
			this.num=0
			this.$refs.common.showLoading();
			this.subForm.id = this.id;
			var obj = this.carhelp.get("form")
			//this.list = [];
			//this.isLoading=true;
			API.upBusNoTicketList(this.subForm).then((res) => {
				this.isLoading=false;
				this.list = res.data.data;
				//this.list = [];
				if(!this.list.length){
					this.$refs.common.showLoading(false);
					if(!bl){
						this.$refs.common.alert("刷新成功");	
					}
					return;
				}
				
		 
				this.selectList=[];//清空选中
				if (this.list.length != 0&&!bl) {
					this.$refs.common.showLoading(false, "刷新成功");
				} else {
					this.$refs.common.showLoading(false);
				}

				

			}).catch(error => {
				this.$refs.common.showLoading(false, error);

			})
		}
	},
	onLoad(op) {
		if(op.back){
			this.noback=op.back
		}
		this.id = op.id
	},
	onReady() {

		if (!this.id) {
			this.$refs.common.goError()
		}
		var obj = this.carhelp.get("form")

		if (obj && obj.name == 'buytickets' && obj.id == this.id) {
			//不创建新订单
			obj.buy=null;
			this.carhelp.set("form",obj);
		} else {
			this.carhelp.set("form", {
				name: 'buytickets',
				id: this.id,
				oplist: [], //当前添加的2人
				list: [] // 一共添加的人 
			});
		}

		if (false&&!this.carhelp.getPersonInfo()) {
			this.$refs.common.setFnc(this.confirmBtn)
			this.$refs.common.alert2('您还不是车信达用户，注册后再购买车票。', '前往注册', '尚未注册')
		} else {
		}
		if (this.noback) {
			 this.upBusNoTicketList(true);
		} else {
			this.getPassengerInfo()
		}
			//this.upBusNoTicketList();
		this.initBl=true;

	},onShow(){
		if(this.initBl){
			 this.upBusNoTicketList(true);
		}	
	}
}
