import * as API from '@/apis/buytickets.js'
import * as Pay from '@/apis/weixin.js'
import {
	wxPayJs
} from '@/utils/wxpay'
 export default {
 	data() {
 		return {
 			total:0,
 			uid: '', //用户id ,有id是修改
 			id: '', //车id
 			type: 2,
 			pnum: 0,
			pic:'',
			personNum:0,
			buy:false,
 			up: {
 				name: '',
 				id: ''
 			},
 			down: {
 				name: '请选择',
 				id: ''
 			},
			oplist:[],
 			ticket: {
 				price1: 0,
 				price2: 0,
 			},
			list:[
				{
					id:1,
					name:"儿童票"
				},{
					id:2,
					name:"成人票"
				}
			],
 			underLine: 1,
 			op: {

 			}
 		}
 	},
 	 
 	methods: {
		
		radioGroupChange(){
			var ptotal=this.getTotal();
			
			ptotal+=parseFloat(this.pnum)
			this.total=ptotal;
		},
		getTotal(){
			var ptotal=0;
			
			for(var i in this.oplist){
				if(this.oplist[i].ticketType=="1"){
					ptotal+=parseFloat(this.ticket.price1*100)
				}
				if(this.oplist[i].ticketType=="2"){
					ptotal+=parseFloat(this.ticket.price2*100)
				}
			}
			return ptotal/100;
		},
		personDelete(){ 
		},
 		deleteBtn() {
			this.$refs.common.setFnc(this.personDelete)
 			 this.$refs.common.confirm('是否删除该乘车人信息？')
 		},
 		select() {
 		 

 			uni.navigateTo({
 				url: '/pages/buytickets/selectSite?select=true&id=' + this.id
 			})
 		},
		submit(id) {
			this.$refs.common.showLoading();
		
		console.log("Pay+"+new Date().getTime())
		
			Pay.wxpay(id).then((response) => {
				if(!response.result){
					this.$refs.common.showLoading(false, response.message);
					return
				}
				var data = response.data
				var url = window.location.href.split("#")[0] + "/#/pages/buytickets/success";
				
				var obj = {
					...data,
					url: url
				}
				console.log("Pay+"+new Date().getTime())
				
				wxPayJs(obj);
		
			}).catch(error => {
				this.$refs.common.showLoading(false, error);
		
			})
		},
 		clickBtn(bl) {
 			var obj = this.carhelp.get("form")
 		
 			//obj = this.carhelp.set("form", obj)
			this.$refs.common.showLoading();
			var arr=[]
			var arr2=[]
			for(var i in obj.oplist){
				arr.push(obj.oplist[i].id);
			}
			for(var i in this.oplist){
				arr2.push(this.oplist[i].ticketType);
			}
			
			var thisform={
				id:this.id,
				mergeOrderId:obj.mergeOrderId,
				openId:this.carhelp.getOpenId(),
				passengerIds:arr.join(),
				ticketUpStationId:this.up.id,
				ticketDownStationId:this.down.id,
				ticketTypes:arr2.join(),
				goodsTicket:this.pnum,
				totalFee:this.total
			}
			if(obj.op){
				 
			}else{
				API.createPassengerOrder(thisform).then((response) => {
				
					if(this.buy||bl==true){
						this.submit(response.data.MergeOrderDTO.id);
					}else{
						obj.oplist=[];
						obj.ticket=null;
						obj = this.carhelp.set("form", obj)
						uni.reLaunch({
							url: '/pages/buytickets/home?id=' + this.id 
						})
					}
					
					console.log(response)
				}).catch(error => {
					this.$refs.common.showLoading(false, error);
				
				})
			}
			
 		},
 		
 	 
 		underLineChange(index) {
 			this.underLine = index;
 			console.log('当前值为: ' + index)

 		},
		ticketAmount(){

			this.$refs.common.showLoading();
			
			var thisform={
				ticketUpStationId:this.up.id,
				ticketDownStationId:this.down.id,	
				ticketDownStationName:this.down.name,
				price1:0,
				price2:0
			}
			thisform.ticketType=1;
			var obj= this.carhelp.get("form");
			 
			API.ticketAmount(thisform).then((response) => {
				thisform.price1=response.data.price
				thisform.ticketType=2;
				API.ticketAmount(thisform).then((response2) => {
					thisform.price2=response2.data.price
					this.ticket=thisform;
					this.radioGroupChange()
					obj.ticket=thisform;
					this.carhelp.set("form",obj);
					this.$refs.common.showLoading(false);
					
				})
				
			
			}).catch(error => {
				this.$refs.common.showLoading(false, error);
			
			})
			
		},
 	},onReady(){
		var obj = this.carhelp.get("form");
		
		if(this.uid && !obj.ticket){
			this.ticketAmount();
		}
		
	},
 	onLoad(op) {
 		this.id = op.id;
 		var obj = this.carhelp.get("form");
		this.buy=obj.buy;
		this.oplist=obj.oplist;
		for(var i  in this.oplist){
			if(!this.oplist[i].ticketType){
				this.oplist[i].ticketType="2"
			}
		}
		
		this.up.name = obj.oplist[0].upStationName;
		this.up.id = obj.oplist[0].upStationId;
		
		this.personNum=obj.oplist.length
		
 		if (obj.ticket) {
 			this.ticket = obj.ticket;
			this.radioGroupChange()
 			this.down = {
 				id: obj.ticket.ticketDownStationId,
 				name: obj.ticket.ticketDownStationName
 			}
 		}
 		
 	}
 }
